﻿using Infragistics.Controls.Charts;
using Infragistics.Windows;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace DataChartAxisLabels
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private bool Switch = false;
        private DateTime start = new DateTime(2011, 3, 1);
        private DateTime end = new DateTime(2011, 3, 2);
        private TestData data;

        public MainWindow()
        {
            InitializeComponent();

            DateTime start = new DateTime(2011, 3, 1);
            DateTime end = start.AddDays(1);
            data = new TestData(start, end, TimeSpan.TicksPerHour / 2);
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            theChart.Axes.Clear();
            theChart.Series.Clear();


            CategoryDateTimeXAxis xAxis = new CategoryDateTimeXAxis();
            NumericYAxis yAxis = new NumericYAxis();

            LineSeries series = new LineSeries();
            series.ItemsSource = data;
            series.XAxis = xAxis;
            series.YAxis = yAxis;
            series.ValueMemberPath = "Value";

            xAxis.DateTimeMemberPath = "Date";
            xAxis.Label = "{Date:HH:mm}";
            xAxis.Interval = new TimeSpan(1, 0, 0);
            xAxis.ItemsSource = data;

            if (Switch)
            {
                xAxis.MinimumValue = start.AddMinutes(-15);
                xAxis.MaximumValue = end.AddMinutes(15);
            }
            Switch = !Switch;

            theChart.Axes.Add(xAxis);
            theChart.Axes.Add(yAxis);
            theChart.Series.Add(series);
        }
    }

    public class TestData : ObservableCollection<TestDataItem>
    {
        private static Random _rand = new Random();

        public TestData(DateTime start, DateTime end, long increment)
        {
            DateTime now = start;
            DateTime dt = start;
            double curr = 10.0;
            while (dt < end)
            {
                if (_rand.NextDouble() < .5)
                {
                    curr += _rand.NextDouble() * 2.0;
                }
                else
                {
                    curr -= _rand.NextDouble() * 2.0;
                }

                Add(new TestDataItem()
                {
                    Date = dt,
                    Value = curr
                });

                dt = dt.AddTicks(increment);
            }
        }
    }

    public class TestDataItem
    {
        public DateTime Date { get; set; }
        public double Value { get; set; }
    }
}
